---
title: User-Agent
slug: Web/HTTP/Headers/User-Agent
tags:
  - HTTP
  - HTTP Header
  - Reference
  - User-agent
---
<div>{{HTTPSidebar}}</div>

<p><span class="seoSummary">The <strong>User-Agent</strong> {{Glossary("request header")}} is a characteristic string that lets servers and network peers identify the application, operating system, vendor, and/or version of the requesting {{Glossary("user agent")}}.</span></p>

<div class="notecard warning">
<p>Please read <a href="/en-US/docs/Web/HTTP/Browser_detection_using_the_user_agent">Browser detection using the user agent</a> for why serving different Web pages or services to different browsers is usually a bad idea.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Request header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">User-Agent: &lt;product&gt; / &lt;product-version&gt; &lt;comment&gt;</pre>

<p>Common format for web browsers:</p>

<pre class="syntaxbox notranslate">User-Agent: Mozilla/5.0 (&lt;system-information&gt;) &lt;platform&gt; (&lt;platform-details&gt;) &lt;extensions&gt;</pre>

<h3 id="Directives">Directives</h3>

<dl>
 <dt><code>&lt;product&gt;</code></dt>
 <dd>A product identifier — its name or development codename.</dd>
 <dt><code>&lt;product-version&gt;</code></dt>
 <dd>Version number of the product.</dd>
 <dt><code>&lt;comment&gt;</code></dt>
 <dd>Zero or more comments containing more details; sub-product information, for example.</dd>
</dl>

<h2 id="Firefox_UA_string">Firefox UA string</h2>

<p>For more on Firefox- and Gecko-based user agent strings, see the <a href="/en-US/docs/Web/HTTP/Headers/User-Agent/Firefox">Firefox user agent string reference</a>. The UA string of Firefox is broken down into 4 components:</p>

<pre class="notranslate">Mozilla/5.0 (<strong><em>platform</em></strong>; rv:<strong><em>geckoversion</em></strong>) Gecko/<strong><em>geckotrail</em></strong> Firefox/<strong><em>firefoxversion</em></strong></pre>

<ol>
 <li><code>Mozilla/5.0</code> is the general token that says the browser is Mozilla-compatible. For historical reasons, almost every browser today sends it.</li>
 <li><strong><em>platform</em></strong> describes the native platform the browser is running on (Windows, Mac, Linux, Android, etc.), and if it's a mobile phone. {{Glossary("Firefox OS")}} phones say <code>Mobile</code> — the web is the platform. Note that <strong><em>platform</em></strong> can consist of multiple "<code>; </code>"-separated tokens. See below for further details and examples.</li>
 <li><strong>rv:<em>geckoversion</em></strong> indicates the release version of Gecko (such as "<em>17.0</em>"). In recent browsers, <strong><em>geckoversion</em></strong> is the same as <strong><em>firefoxversion</em></strong>.</li>
 <li><strong><em>Gecko/geckotrail</em></strong> indicates that the browser is based on <a href="/en-US/docs/Mozilla/Gecko">Gecko</a>. (On Desktop, <em><strong>geckotrail</strong></em> is always the fixed string <code>20100101</code>.)</li>
 <li><em><strong>Firefox/firefoxversion</strong></em> indicates the browser is Firefox, and provides the version (such as "<em>17.0"</em>).</li>
</ol>

<h3 id="Examples">Examples</h3>

<pre class="no-line-numbers notranslate">Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:47.0) Gecko/20100101 Firefox/47.0
Mozilla/5.0 (Macintosh; Intel Mac OS X <em>x.y</em>; rv:42.0) Gecko/20100101 Firefox/42.0
</pre>

<h2 id="Chrome_UA_string">Chrome UA string</h2>

<p>The Chrome (or Chromium/Blink-based engines) user agent string is similar to Firefox’s. For compatibility, it adds strings like <code>KHTML, like Gecko</code> and <code>Safari</code>.</p>

<h3 id="Examples_2">Examples</h3>

<pre class="no-line-numbers notranslate">Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/51.0.2704.103 Safari/537.36</pre>

<h2 id="Opera_UA_string">Opera UA string</h2>

<p>The Opera browser is also based on the Blink engine, which is why it almost looks the same, but adds <code>"OPR/&lt;version&gt;"</code>.</p>

<h3 id="Examples_3">Examples</h3>

<pre class="no-line-numbers notranslate">Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/51.0.2704.106 Safari/537.36 OPR/38.0.2220.41</pre>

<p>Older, Presto-based Opera releases used:</p>

<pre class="no-line-numbers notranslate">Opera/9.80 (Macintosh; Intel Mac OS X; U; en) Presto/2.2.15 Version/10.00
Opera/9.60 (Windows NT 6.0; U; en) Presto/2.1.1</pre>

<h2 id="Safari_UA_string">Safari UA string</h2>

<p>In this example, the user agent string is mobile Safari’s version. It contains the word <code>"Mobile"</code>.</p>

<h3 id="Examples_4">Examples</h3>

<pre class="no-line-numbers notranslate">Mozilla/5.0 (iPhone; CPU iPhone OS 13_5_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Mobile/15E148 Safari/604.1</pre>

<h2 id="Internet_Explorer_UA_string">Internet Explorer UA string</h2>

<h3 id="Examples_5">Examples</h3>

<pre class="no-line-numbers notranslate">Mozilla/5.0 (compatible; MSIE 9.0; Windows Phone OS 7.5; Trident/5.0; IEMobile/9.0)</pre>

<h2 id="Crawler_and_bot_UA_strings">Crawler and bot UA strings</h2>

<h3 id="Examples_6">Examples</h3>

<pre class="no-line-numbers notranslate">Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)</pre>

<pre class="no-line-numbers notranslate">Mozilla/5.0 (compatible; YandexAccessibilityBot/3.0; +http://yandex.com/bots)</pre>

<h2 id="Library_and_net_tool_UA_strings">Library and net tool UA strings</h2>

<h3 id="Examples_7">Examples</h3>

<pre class="no-line-numbers notranslate">curl/7.64.1</pre>

<pre class="no-line-numbers notranslate">PostmanRuntime/7.26.5</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC(7231, "User-Agent", "5.5.3")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content</td>
  </tr>
  <tr>
   <td>{{RFC(2616, "User-Agent", "14.43")}}</td>
   <td>Hypertext Transfer Protocol -- HTTP/1.1</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.User-Agent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://hacks.mozilla.org/2013/09/user-agent-detection-history-and-checklist/">User-Agent detection, history and checklist</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Headers/User-Agent/Firefox">Firefox user agent string reference</a></li>
 <li>
  <p><a href="/en-US/docs/Web/HTTP/Browser_detection_using_the_user_agent">Browser detection using the user agent</a></p>
 </li>
</ul>
